/****************************************************************/
/*  
     ***   ***  ***  *** ***     *** ***   ******  ****  ***
     ***   ***  ***  *** ***     *** **   ***  *** ***** ***
     ***   ***  ***  *** ***     *****    ******** *** *****
      *** ***   ***  *** ******* *** **   ***  *** ***  ****
       *****     *****   ******* *** ***  ***  *** ***   ***
	   
	 Vulkan Graphics API: in 20 Minutes (Coffee Break Series)
	 Beginners Taste

     Minimal working examples (MWE) to build upon and 
	 modify to gain an understanding of the API

	 Extensions to the Vulkan Graphics Coffee Break Series
	   
/*
/****************************************************************/


#version 420

layout (location = 0) in vec4 inPos;
layout (location = 1) in vec2 inUV;
layout (location = 2) in vec3 inColor;
layout (location = 3) in vec3 inNormal;


layout (binding = 0) uniform UBO 
{
	mat4  MVP;
	mat4  LightMVP;
} ubo;


layout (location = 0) out vec4  outCPosition;
layout (location = 1) out vec4  outLPosition;
layout (location = 2) out vec3  outNormal;


out gl_PerVertex
{
	vec4 gl_Position;
};

void main() 
{
	gl_Position  = ubo.MVP * inPos;	
	outCPosition = gl_Position;					
	outLPosition = ubo.LightMVP * inPos; 
	outLPosition.z += 0.4;	
	outNormal	 = normalize(inNormal);         
}
